/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSMockContentFilterSettings_h
#define JSMockContentFilterSettings_h

#if ENABLE(CONTENT_FILTERING)

#include "JSDOMWrapper.h"
#include "MockContentFilterSettings.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSMockContentFilterSettings : public JSDOMWrapper {
public:
    typedef JSDOMWrapper Base;
    static JSMockContentFilterSettings* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<MockContentFilterSettings>&& impl)
    {
        JSMockContentFilterSettings* ptr = new (NotNull, JSC::allocateCell<JSMockContentFilterSettings>(globalObject->vm().heap)) JSMockContentFilterSettings(structure, globalObject, WTF::move(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static JSC::JSObject* getPrototype(JSC::VM&, JSC::JSGlobalObject*);
    static MockContentFilterSettings* toWrapped(JSC::JSValue);
    static bool getOwnPropertySlot(JSC::JSObject*, JSC::ExecState*, JSC::PropertyName, JSC::PropertySlot&);
    static void destroy(JSC::JSCell*);
    ~JSMockContentFilterSettings();

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }


    // Custom attributes
    JSC::JSValue decisionPoint(JSC::ExecState*) const;
    void setDecisionPoint(JSC::ExecState*, JSC::JSValue);
    JSC::JSValue decision(JSC::ExecState*) const;
    void setDecision(JSC::ExecState*, JSC::JSValue);
    JSC::JSValue unblockRequestDecision(JSC::ExecState*) const;
    void setUnblockRequestDecision(JSC::ExecState*, JSC::JSValue);
    MockContentFilterSettings& impl() const { return *m_impl; }
    void releaseImpl() { std::exchange(m_impl, nullptr)->deref(); }

private:
    MockContentFilterSettings* m_impl;
public:
    static const unsigned StructureFlags = JSC::OverridesGetOwnPropertySlot | Base::StructureFlags;
protected:
    JSMockContentFilterSettings(JSC::Structure*, JSDOMGlobalObject*, Ref<MockContentFilterSettings>&&);

    void finishCreation(JSC::VM& vm)
    {
        Base::finishCreation(vm);
        ASSERT(inherits(info()));
    }

};

class JSMockContentFilterSettingsOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, MockContentFilterSettings*)
{
    static NeverDestroyed<JSMockContentFilterSettingsOwner> owner;
    return &owner.get();
}

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, MockContentFilterSettings*);
inline JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, MockContentFilterSettings& impl) { return toJS(exec, globalObject, &impl); }


} // namespace WebCore

#endif // ENABLE(CONTENT_FILTERING)

#endif
