/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(MEDIA_STREAM)

#include "JSAllVideoCapabilities.h"

#include "AllVideoCapabilities.h"
#include "CapabilityRange.h"
#include "DOMStringList.h"
#include "JSCapabilityRange.h"
#include "JSDOMBinding.h"
#include "JSDOMStringList.h"
#include <runtime/JSArray.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Attributes

JSC::EncodedJSValue jsAllVideoCapabilitiesSourceType(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsAllVideoCapabilitiesSourceId(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsAllVideoCapabilitiesWidth(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsAllVideoCapabilitiesHeight(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsAllVideoCapabilitiesFrameRate(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsAllVideoCapabilitiesAspectRatio(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsAllVideoCapabilitiesFacingMode(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);

class JSAllVideoCapabilitiesPrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSAllVideoCapabilitiesPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSAllVideoCapabilitiesPrototype* ptr = new (NotNull, JSC::allocateCell<JSAllVideoCapabilitiesPrototype>(vm.heap)) JSAllVideoCapabilitiesPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSAllVideoCapabilitiesPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

/* Hash table for prototype */

static const HashTableValue JSAllVideoCapabilitiesPrototypeTableValues[] =
{
    { "sourceType", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAllVideoCapabilitiesSourceType), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "sourceId", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAllVideoCapabilitiesSourceId), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "width", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAllVideoCapabilitiesWidth), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "height", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAllVideoCapabilitiesHeight), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "frameRate", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAllVideoCapabilitiesFrameRate), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "aspectRatio", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAllVideoCapabilitiesAspectRatio), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "facingMode", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAllVideoCapabilitiesFacingMode), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
};

const ClassInfo JSAllVideoCapabilitiesPrototype::s_info = { "AllVideoCapabilitiesPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSAllVideoCapabilitiesPrototype) };

void JSAllVideoCapabilitiesPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSAllVideoCapabilitiesPrototypeTableValues, *this);
}

const ClassInfo JSAllVideoCapabilities::s_info = { "AllVideoCapabilities", &Base::s_info, 0, CREATE_METHOD_TABLE(JSAllVideoCapabilities) };

JSAllVideoCapabilities::JSAllVideoCapabilities(Structure* structure, JSDOMGlobalObject* globalObject, Ref<AllVideoCapabilities>&& impl)
    : JSMediaStreamCapabilities(structure, globalObject, WTF::move(impl))
{
}

JSObject* JSAllVideoCapabilities::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSAllVideoCapabilitiesPrototype::create(vm, globalObject, JSAllVideoCapabilitiesPrototype::createStructure(vm, globalObject, JSMediaStreamCapabilities::getPrototype(vm, globalObject)));
}

JSObject* JSAllVideoCapabilities::getPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSAllVideoCapabilities>(vm, globalObject);
}

EncodedJSValue jsAllVideoCapabilitiesSourceType(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSAllVideoCapabilities* castedThis = jsDynamicCast<JSAllVideoCapabilities*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSAllVideoCapabilitiesPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "AllVideoCapabilities", "sourceType");
        return throwGetterTypeError(*exec, "AllVideoCapabilities", "sourceType");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsArray(exec, castedThis->globalObject(), impl.sourceType());
    return JSValue::encode(result);
}


EncodedJSValue jsAllVideoCapabilitiesSourceId(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSAllVideoCapabilities* castedThis = jsDynamicCast<JSAllVideoCapabilities*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSAllVideoCapabilitiesPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "AllVideoCapabilities", "sourceId");
        return throwGetterTypeError(*exec, "AllVideoCapabilities", "sourceId");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsArray(exec, castedThis->globalObject(), impl.sourceId());
    return JSValue::encode(result);
}


EncodedJSValue jsAllVideoCapabilitiesWidth(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSAllVideoCapabilities* castedThis = jsDynamicCast<JSAllVideoCapabilities*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSAllVideoCapabilitiesPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "AllVideoCapabilities", "width");
        return throwGetterTypeError(*exec, "AllVideoCapabilities", "width");
    }
    auto& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.width()));
    return JSValue::encode(result);
}


EncodedJSValue jsAllVideoCapabilitiesHeight(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSAllVideoCapabilities* castedThis = jsDynamicCast<JSAllVideoCapabilities*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSAllVideoCapabilitiesPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "AllVideoCapabilities", "height");
        return throwGetterTypeError(*exec, "AllVideoCapabilities", "height");
    }
    auto& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.height()));
    return JSValue::encode(result);
}


EncodedJSValue jsAllVideoCapabilitiesFrameRate(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSAllVideoCapabilities* castedThis = jsDynamicCast<JSAllVideoCapabilities*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSAllVideoCapabilitiesPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "AllVideoCapabilities", "frameRate");
        return throwGetterTypeError(*exec, "AllVideoCapabilities", "frameRate");
    }
    auto& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.frameRate()));
    return JSValue::encode(result);
}


EncodedJSValue jsAllVideoCapabilitiesAspectRatio(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSAllVideoCapabilities* castedThis = jsDynamicCast<JSAllVideoCapabilities*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSAllVideoCapabilitiesPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "AllVideoCapabilities", "aspectRatio");
        return throwGetterTypeError(*exec, "AllVideoCapabilities", "aspectRatio");
    }
    auto& impl = castedThis->impl();
    JSValue result = toJS(exec, castedThis->globalObject(), WTF::getPtr(impl.aspectRatio()));
    return JSValue::encode(result);
}


EncodedJSValue jsAllVideoCapabilitiesFacingMode(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSAllVideoCapabilities* castedThis = jsDynamicCast<JSAllVideoCapabilities*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSAllVideoCapabilitiesPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "AllVideoCapabilities", "facingMode");
        return throwGetterTypeError(*exec, "AllVideoCapabilities", "facingMode");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsArray(exec, castedThis->globalObject(), impl.facingMode());
    return JSValue::encode(result);
}


#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7AllVideoCapabilities@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore20AllVideoCapabilitiesE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject* globalObject, AllVideoCapabilities* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSAllVideoCapabilities>(globalObject, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7AllVideoCapabilities@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore20AllVideoCapabilitiesE[2];
#if COMPILER(CLANG)
    // If this fails AllVideoCapabilities does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(AllVideoCapabilities), AllVideoCapabilities_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // AllVideoCapabilities has subclasses. If AllVideoCapabilities has subclasses that get passed
    // to toJS() we currently require AllVideoCapabilities you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createNewWrapper<JSAllVideoCapabilities>(globalObject, impl);
}


}

#endif // ENABLE(MEDIA_STREAM)
