/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSQuickTimePluginReplacement.h"

#include "ExceptionCode.h"
#include "JSDOMBinding.h"
#include "QuickTimePluginReplacement.h"
#include <runtime/Error.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsQuickTimePluginReplacementPrototypeFunctionPostEvent(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsQuickTimePluginReplacementMovieSize(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsQuickTimePluginReplacementTimedMetaData(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsQuickTimePluginReplacementAccessLog(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsQuickTimePluginReplacementErrorLog(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);

class JSQuickTimePluginReplacementPrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSQuickTimePluginReplacementPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSQuickTimePluginReplacementPrototype* ptr = new (NotNull, JSC::allocateCell<JSQuickTimePluginReplacementPrototype>(vm.heap)) JSQuickTimePluginReplacementPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSQuickTimePluginReplacementPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

/* Hash table */

static const struct CompactHashIndex JSQuickTimePluginReplacementTableIndex[8] = {
    { -1, -1 },
    { 2, -1 },
    { -1, -1 },
    { -1, -1 },
    { 0, -1 },
    { 1, -1 },
    { -1, -1 },
    { -1, -1 },
};


static const HashTableValue JSQuickTimePluginReplacementTableValues[] =
{
    { "timedMetaData", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsQuickTimePluginReplacementTimedMetaData), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "accessLog", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsQuickTimePluginReplacementAccessLog), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "errorLog", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsQuickTimePluginReplacementErrorLog), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
};

static const HashTable JSQuickTimePluginReplacementTable = { 3, 7, true, JSQuickTimePluginReplacementTableValues, 0, JSQuickTimePluginReplacementTableIndex };
/* Hash table for prototype */

static const HashTableValue JSQuickTimePluginReplacementPrototypeTableValues[] =
{
    { "movieSize", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsQuickTimePluginReplacementMovieSize), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "postEvent", DontDelete | JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsQuickTimePluginReplacementPrototypeFunctionPostEvent), (intptr_t) (1) },
};

const ClassInfo JSQuickTimePluginReplacementPrototype::s_info = { "QuickTimePluginReplacementPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSQuickTimePluginReplacementPrototype) };

void JSQuickTimePluginReplacementPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSQuickTimePluginReplacementPrototypeTableValues, *this);
}

const ClassInfo JSQuickTimePluginReplacement::s_info = { "QuickTimePluginReplacement", &Base::s_info, &JSQuickTimePluginReplacementTable, CREATE_METHOD_TABLE(JSQuickTimePluginReplacement) };

JSQuickTimePluginReplacement::JSQuickTimePluginReplacement(Structure* structure, JSDOMGlobalObject* globalObject, Ref<QuickTimePluginReplacement>&& impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(&impl.leakRef())
{
}

JSObject* JSQuickTimePluginReplacement::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSQuickTimePluginReplacementPrototype::create(vm, globalObject, JSQuickTimePluginReplacementPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSQuickTimePluginReplacement::getPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSQuickTimePluginReplacement>(vm, globalObject);
}

void JSQuickTimePluginReplacement::destroy(JSC::JSCell* cell)
{
    JSQuickTimePluginReplacement* thisObject = static_cast<JSQuickTimePluginReplacement*>(cell);
    thisObject->JSQuickTimePluginReplacement::~JSQuickTimePluginReplacement();
}

JSQuickTimePluginReplacement::~JSQuickTimePluginReplacement()
{
    releaseImpl();
}

bool JSQuickTimePluginReplacement::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    auto* thisObject = jsCast<JSQuickTimePluginReplacement*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSQuickTimePluginReplacement, Base>(exec, JSQuickTimePluginReplacementTable, thisObject, propertyName, slot);
}

EncodedJSValue jsQuickTimePluginReplacementMovieSize(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSQuickTimePluginReplacement* castedThis = jsDynamicCast<JSQuickTimePluginReplacement*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSQuickTimePluginReplacementPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "QuickTimePluginReplacement", "movieSize");
        return throwGetterTypeError(*exec, "QuickTimePluginReplacement", "movieSize");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsNumber(impl.movieSize());
    return JSValue::encode(result);
}


EncodedJSValue jsQuickTimePluginReplacementTimedMetaData(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    auto* castedThis = jsCast<JSQuickTimePluginReplacement*>(slotBase);
    return JSValue::encode(castedThis->timedMetaData(exec));
}


EncodedJSValue jsQuickTimePluginReplacementAccessLog(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    auto* castedThis = jsCast<JSQuickTimePluginReplacement*>(slotBase);
    return JSValue::encode(castedThis->accessLog(exec));
}


EncodedJSValue jsQuickTimePluginReplacementErrorLog(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    auto* castedThis = jsCast<JSQuickTimePluginReplacement*>(slotBase);
    return JSValue::encode(castedThis->errorLog(exec));
}


EncodedJSValue JSC_HOST_CALL jsQuickTimePluginReplacementPrototypeFunctionPostEvent(ExecState* exec)
{
    JSValue thisValue = exec->thisValue();
    JSQuickTimePluginReplacement* castedThis = jsDynamicCast<JSQuickTimePluginReplacement*>(thisValue);
    if (UNLIKELY(!castedThis))
        return throwThisTypeError(*exec, "QuickTimePluginReplacement", "postEvent");
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSQuickTimePluginReplacement::info());
    auto& impl = castedThis->impl();
    if (UNLIKELY(exec->argumentCount() < 1))
        return throwVMError(exec, createNotEnoughArgumentsError(exec));
    String eventName = exec->argument(0).toString(exec)->value(exec);
    if (UNLIKELY(exec->hadException()))
        return JSValue::encode(jsUndefined());
    impl.postEvent(eventName);
    return JSValue::encode(jsUndefined());
}

bool JSQuickTimePluginReplacementOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSQuickTimePluginReplacementOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsQuickTimePluginReplacement = jsCast<JSQuickTimePluginReplacement*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsQuickTimePluginReplacement->impl(), jsQuickTimePluginReplacement);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7QuickTimePluginReplacement@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore26QuickTimePluginReplacementE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject* globalObject, QuickTimePluginReplacement* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSQuickTimePluginReplacement>(globalObject, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7QuickTimePluginReplacement@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore26QuickTimePluginReplacementE[2];
#if COMPILER(CLANG)
    // If this fails QuickTimePluginReplacement does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(QuickTimePluginReplacement), QuickTimePluginReplacement_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // QuickTimePluginReplacement has subclasses. If QuickTimePluginReplacement has subclasses that get passed
    // to toJS() we currently require QuickTimePluginReplacement you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createNewWrapper<JSQuickTimePluginReplacement>(globalObject, impl);
}

QuickTimePluginReplacement* JSQuickTimePluginReplacement::toWrapped(JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSQuickTimePluginReplacement*>(value))
        return &wrapper->impl();
    return nullptr;
}

}
