/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(MEDIA_SESSION)

#include "JSMediaRemoteControls.h"

#include "ExceptionCode.h"
#include "JSDOMBinding.h"
#include "JSEventListener.h"
#include "MediaRemoteControls.h"
#include <runtime/Error.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Attributes

JSC::EncodedJSValue jsMediaRemoteControlsPreviousTrackEnabled(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
void setJSMediaRemoteControlsPreviousTrackEnabled(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsMediaRemoteControlsNextTrackEnabled(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
void setJSMediaRemoteControlsNextTrackEnabled(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsMediaRemoteControlsOnprevioustrack(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
void setJSMediaRemoteControlsOnprevioustrack(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsMediaRemoteControlsOnnexttrack(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
void setJSMediaRemoteControlsOnnexttrack(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsMediaRemoteControlsConstructor(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);

class JSMediaRemoteControlsPrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSMediaRemoteControlsPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSMediaRemoteControlsPrototype* ptr = new (NotNull, JSC::allocateCell<JSMediaRemoteControlsPrototype>(vm.heap)) JSMediaRemoteControlsPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSMediaRemoteControlsPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

class JSMediaRemoteControlsConstructor : public DOMConstructorObject {
private:
    JSMediaRemoteControlsConstructor(JSC::Structure*, JSDOMGlobalObject*);
    void finishCreation(JSC::VM&, JSDOMGlobalObject*);

public:
    typedef DOMConstructorObject Base;
    static JSMediaRemoteControlsConstructor* create(JSC::VM& vm, JSC::Structure* structure, JSDOMGlobalObject* globalObject)
    {
        JSMediaRemoteControlsConstructor* ptr = new (NotNull, JSC::allocateCell<JSMediaRemoteControlsConstructor>(vm.heap)) JSMediaRemoteControlsConstructor(structure, globalObject);
        ptr->finishCreation(vm, globalObject);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }
protected:
    static JSC::EncodedJSValue JSC_HOST_CALL constructJSMediaRemoteControls(JSC::ExecState*);
    static JSC::ConstructType getConstructData(JSC::JSCell*, JSC::ConstructData&);
};

EncodedJSValue JSC_HOST_CALL JSMediaRemoteControlsConstructor::constructJSMediaRemoteControls(ExecState* exec)
{
    auto* castedThis = jsCast<JSMediaRemoteControlsConstructor*>(exec->callee());
    ScriptExecutionContext* context = castedThis->scriptExecutionContext();
    if (!context)
        return throwConstructorDocumentUnavailableError(*exec, "MediaRemoteControls");
    RefPtr<MediaRemoteControls> object = MediaRemoteControls::create(*context);
    return JSValue::encode(asObject(toJS(exec, castedThis->globalObject(), object.get())));
}

const ClassInfo JSMediaRemoteControlsConstructor::s_info = { "MediaRemoteControlsConstructor", &Base::s_info, 0, CREATE_METHOD_TABLE(JSMediaRemoteControlsConstructor) };

JSMediaRemoteControlsConstructor::JSMediaRemoteControlsConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSMediaRemoteControlsConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, JSMediaRemoteControls::getPrototype(vm, globalObject), DontDelete | ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("MediaRemoteControls"))), ReadOnly | DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontEnum);
}

ConstructType JSMediaRemoteControlsConstructor::getConstructData(JSCell*, ConstructData& constructData)
{
    constructData.native.function = constructJSMediaRemoteControls;
    return ConstructTypeHost;
}

/* Hash table for prototype */

static const HashTableValue JSMediaRemoteControlsPrototypeTableValues[] =
{
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaRemoteControlsConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "previousTrackEnabled", DontDelete | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaRemoteControlsPreviousTrackEnabled), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMediaRemoteControlsPreviousTrackEnabled) },
    { "nextTrackEnabled", DontDelete | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaRemoteControlsNextTrackEnabled), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMediaRemoteControlsNextTrackEnabled) },
    { "onprevioustrack", DontDelete | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaRemoteControlsOnprevioustrack), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMediaRemoteControlsOnprevioustrack) },
    { "onnexttrack", DontDelete | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsMediaRemoteControlsOnnexttrack), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSMediaRemoteControlsOnnexttrack) },
};

const ClassInfo JSMediaRemoteControlsPrototype::s_info = { "MediaRemoteControlsPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSMediaRemoteControlsPrototype) };

void JSMediaRemoteControlsPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSMediaRemoteControlsPrototypeTableValues, *this);
}

const ClassInfo JSMediaRemoteControls::s_info = { "MediaRemoteControls", &Base::s_info, 0, CREATE_METHOD_TABLE(JSMediaRemoteControls) };

JSMediaRemoteControls::JSMediaRemoteControls(Structure* structure, JSDOMGlobalObject* globalObject, Ref<MediaRemoteControls>&& impl)
    : JSEventTarget(structure, globalObject, WTF::move(impl))
{
}

JSObject* JSMediaRemoteControls::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSMediaRemoteControlsPrototype::create(vm, globalObject, JSMediaRemoteControlsPrototype::createStructure(vm, globalObject, JSEventTarget::getPrototype(vm, globalObject)));
}

JSObject* JSMediaRemoteControls::getPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSMediaRemoteControls>(vm, globalObject);
}

EncodedJSValue jsMediaRemoteControlsPreviousTrackEnabled(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSMediaRemoteControls* castedThis = jsDynamicCast<JSMediaRemoteControls*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSMediaRemoteControlsPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "MediaRemoteControls", "previousTrackEnabled");
        return throwGetterTypeError(*exec, "MediaRemoteControls", "previousTrackEnabled");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsBoolean(impl.previousTrackEnabled());
    return JSValue::encode(result);
}


EncodedJSValue jsMediaRemoteControlsNextTrackEnabled(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSMediaRemoteControls* castedThis = jsDynamicCast<JSMediaRemoteControls*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSMediaRemoteControlsPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "MediaRemoteControls", "nextTrackEnabled");
        return throwGetterTypeError(*exec, "MediaRemoteControls", "nextTrackEnabled");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsBoolean(impl.nextTrackEnabled());
    return JSValue::encode(result);
}


EncodedJSValue jsMediaRemoteControlsOnprevioustrack(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSMediaRemoteControls* castedThis = jsDynamicCast<JSMediaRemoteControls*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSMediaRemoteControlsPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "MediaRemoteControls", "onprevioustrack");
        return throwGetterTypeError(*exec, "MediaRemoteControls", "onprevioustrack");
    }
    UNUSED_PARAM(exec);
    return JSValue::encode(eventHandlerAttribute(castedThis->impl(), eventNames().previoustrackEvent));
}


EncodedJSValue jsMediaRemoteControlsOnnexttrack(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSMediaRemoteControls* castedThis = jsDynamicCast<JSMediaRemoteControls*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSMediaRemoteControlsPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "MediaRemoteControls", "onnexttrack");
        return throwGetterTypeError(*exec, "MediaRemoteControls", "onnexttrack");
    }
    UNUSED_PARAM(exec);
    return JSValue::encode(eventHandlerAttribute(castedThis->impl(), eventNames().nexttrackEvent));
}


EncodedJSValue jsMediaRemoteControlsConstructor(ExecState* exec, JSObject* baseValue, EncodedJSValue, PropertyName)
{
    JSMediaRemoteControlsPrototype* domObject = jsDynamicCast<JSMediaRemoteControlsPrototype*>(baseValue);
    if (!domObject)
        return throwVMTypeError(exec);
    return JSValue::encode(JSMediaRemoteControls::getConstructor(exec->vm(), domObject->globalObject()));
}

void setJSMediaRemoteControlsPreviousTrackEnabled(ExecState* exec, JSObject* baseObject, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    JSValue value = JSValue::decode(encodedValue);
    UNUSED_PARAM(baseObject);
    JSMediaRemoteControls* castedThis = jsDynamicCast<JSMediaRemoteControls*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSMediaRemoteControlsPrototype*>(JSValue::decode(thisValue)))
            reportDeprecatedSetterError(*exec, "MediaRemoteControls", "previousTrackEnabled");
        else
            throwSetterTypeError(*exec, "MediaRemoteControls", "previousTrackEnabled");
        return;
    }
    auto& impl = castedThis->impl();
    bool nativeValue = value.toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return;
    impl.setPreviousTrackEnabled(nativeValue);
}


void setJSMediaRemoteControlsNextTrackEnabled(ExecState* exec, JSObject* baseObject, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    JSValue value = JSValue::decode(encodedValue);
    UNUSED_PARAM(baseObject);
    JSMediaRemoteControls* castedThis = jsDynamicCast<JSMediaRemoteControls*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSMediaRemoteControlsPrototype*>(JSValue::decode(thisValue)))
            reportDeprecatedSetterError(*exec, "MediaRemoteControls", "nextTrackEnabled");
        else
            throwSetterTypeError(*exec, "MediaRemoteControls", "nextTrackEnabled");
        return;
    }
    auto& impl = castedThis->impl();
    bool nativeValue = value.toBoolean(exec);
    if (UNLIKELY(exec->hadException()))
        return;
    impl.setNextTrackEnabled(nativeValue);
}


void setJSMediaRemoteControlsOnprevioustrack(ExecState* exec, JSObject* baseObject, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    JSValue value = JSValue::decode(encodedValue);
    UNUSED_PARAM(baseObject);
    JSMediaRemoteControls* castedThis = jsDynamicCast<JSMediaRemoteControls*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSMediaRemoteControlsPrototype*>(JSValue::decode(thisValue)))
            reportDeprecatedSetterError(*exec, "MediaRemoteControls", "onprevioustrack");
        else
            throwSetterTypeError(*exec, "MediaRemoteControls", "onprevioustrack");
        return;
    }
    setEventHandlerAttribute(*exec, *castedThis, castedThis->impl(), eventNames().previoustrackEvent, value);
}


void setJSMediaRemoteControlsOnnexttrack(ExecState* exec, JSObject* baseObject, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    JSValue value = JSValue::decode(encodedValue);
    UNUSED_PARAM(baseObject);
    JSMediaRemoteControls* castedThis = jsDynamicCast<JSMediaRemoteControls*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSMediaRemoteControlsPrototype*>(JSValue::decode(thisValue)))
            reportDeprecatedSetterError(*exec, "MediaRemoteControls", "onnexttrack");
        else
            throwSetterTypeError(*exec, "MediaRemoteControls", "onnexttrack");
        return;
    }
    setEventHandlerAttribute(*exec, *castedThis, castedThis->impl(), eventNames().nexttrackEvent, value);
}


JSValue JSMediaRemoteControls::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSMediaRemoteControlsConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}

void JSMediaRemoteControls::visitChildren(JSCell* cell, SlotVisitor& visitor)
{
    auto* thisObject = jsCast<JSMediaRemoteControls*>(cell);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    Base::visitChildren(thisObject, visitor);
    thisObject->impl().visitJSEventListeners(visitor);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7MediaRemoteControls@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore19MediaRemoteControlsE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject* globalObject, MediaRemoteControls* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSMediaRemoteControls>(globalObject, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7MediaRemoteControls@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore19MediaRemoteControlsE[2];
#if COMPILER(CLANG)
    // If this fails MediaRemoteControls does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(MediaRemoteControls), MediaRemoteControls_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // MediaRemoteControls has subclasses. If MediaRemoteControls has subclasses that get passed
    // to toJS() we currently require MediaRemoteControls you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createNewWrapper<JSMediaRemoteControls>(globalObject, impl);
}


}

#endif // ENABLE(MEDIA_SESSION)
