/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(MEDIA_STREAM)

#include "JSSourceInfo.h"

#include "JSDOMBinding.h"
#include "SourceInfo.h"
#include "URL.h"
#include <runtime/JSString.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

// Attributes

JSC::EncodedJSValue jsSourceInfoSourceId(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsSourceInfoKind(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsSourceInfoLabel(JSC::ExecState*, JSC::JSObject*, JSC::EncodedJSValue, JSC::PropertyName);

class JSSourceInfoPrototype : public JSC::JSNonFinalObject {
public:
    typedef JSC::JSNonFinalObject Base;
    static JSSourceInfoPrototype* create(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSSourceInfoPrototype* ptr = new (NotNull, JSC::allocateCell<JSSourceInfoPrototype>(vm.heap)) JSSourceInfoPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSSourceInfoPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

/* Hash table for prototype */

static const HashTableValue JSSourceInfoPrototypeTableValues[] =
{
    { "sourceId", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSourceInfoSourceId), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "kind", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSourceInfoKind), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "label", DontDelete | ReadOnly | CustomAccessor, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSourceInfoLabel), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
};

const ClassInfo JSSourceInfoPrototype::s_info = { "SourceInfoPrototype", &Base::s_info, 0, CREATE_METHOD_TABLE(JSSourceInfoPrototype) };

void JSSourceInfoPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSSourceInfoPrototypeTableValues, *this);
}

const ClassInfo JSSourceInfo::s_info = { "SourceInfo", &Base::s_info, 0, CREATE_METHOD_TABLE(JSSourceInfo) };

JSSourceInfo::JSSourceInfo(Structure* structure, JSDOMGlobalObject* globalObject, Ref<SourceInfo>&& impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(&impl.leakRef())
{
}

JSObject* JSSourceInfo::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSSourceInfoPrototype::create(vm, globalObject, JSSourceInfoPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

JSObject* JSSourceInfo::getPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSSourceInfo>(vm, globalObject);
}

void JSSourceInfo::destroy(JSC::JSCell* cell)
{
    JSSourceInfo* thisObject = static_cast<JSSourceInfo*>(cell);
    thisObject->JSSourceInfo::~JSSourceInfo();
}

JSSourceInfo::~JSSourceInfo()
{
    releaseImpl();
}

EncodedJSValue jsSourceInfoSourceId(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSSourceInfo* castedThis = jsDynamicCast<JSSourceInfo*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSSourceInfoPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "SourceInfo", "sourceId");
        return throwGetterTypeError(*exec, "SourceInfo", "sourceId");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.sourceId());
    return JSValue::encode(result);
}


EncodedJSValue jsSourceInfoKind(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSSourceInfo* castedThis = jsDynamicCast<JSSourceInfo*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSSourceInfoPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "SourceInfo", "kind");
        return throwGetterTypeError(*exec, "SourceInfo", "kind");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.kind());
    return JSValue::encode(result);
}


EncodedJSValue jsSourceInfoLabel(ExecState* exec, JSObject* slotBase, EncodedJSValue thisValue, PropertyName)
{
    UNUSED_PARAM(exec);
    UNUSED_PARAM(slotBase);
    UNUSED_PARAM(thisValue);
    JSSourceInfo* castedThis = jsDynamicCast<JSSourceInfo*>(JSValue::decode(thisValue));
    if (UNLIKELY(!castedThis)) {
        if (jsDynamicCast<JSSourceInfoPrototype*>(slotBase))
            return reportDeprecatedGetterError(*exec, "SourceInfo", "label");
        return throwGetterTypeError(*exec, "SourceInfo", "label");
    }
    auto& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.label());
    return JSValue::encode(result);
}


bool JSSourceInfoOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSSourceInfoOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsSourceInfo = jsCast<JSSourceInfo*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsSourceInfo->impl(), jsSourceInfo);
}

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject* globalObject, SourceInfo* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSSourceInfo>(globalObject, impl))
        return result;
#if COMPILER(CLANG)
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to SourceInfo.
    COMPILE_ASSERT(!__is_polymorphic(SourceInfo), SourceInfo_is_polymorphic_but_idl_claims_not_to_be);
#endif
    return createNewWrapper<JSSourceInfo>(globalObject, impl);
}

SourceInfo* JSSourceInfo::toWrapped(JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSSourceInfo*>(value))
        return &wrapper->impl();
    return nullptr;
}

}

#endif // ENABLE(MEDIA_STREAM)
